function [ys,check] = FinIntGov_steadystate(ys,exe)
global M_

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% dis_lab, chi and lambda_ss are no longer parameters but defined within
% the "model-section" through #dis_lab = ..., #chi = ..., #lambda_ss = ...
alpha       = M_.params(1);
beta        = M_.params(2);
gamma       = M_.params(3);
delta       = M_.params(4);
upsilon     = M_.params(5);
varphi      = M_.params(6);
kappa_p     = M_.params(7);
kappa_w     = M_.params(8);
epsilon_p   = M_.params(9);
epsilon_w   = M_.params(10);
psi         = M_.params(11);
psi_w       = M_.params(12);
gamma_p     = M_.params(13);
gamma_w     = M_.params(14);
if 1
    % if theta is estimated
    theta       = M_.params(15);
    lambda_b_k  = M_.params(16);
    rho         = M_.params(17);
    r_c         = M_.params(18);
    vartheta_cf = M_.params(19);
    vartheta_p  = M_.params(20);
else
    % if chi is estimated
    lambda_b_k  = M_.params(15);
    rho         = M_.params(16);
    r_c         = M_.params(17);
    chi         = M_.params(18);
end
vartheta_cf = M_.params(19);
vartheta_p  = M_.params(20);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% uncomment this part if dis_lab, chi and lambda_ss are parameters

% alpha       = M_.params(1);
% beta        = M_.params(2);
% gamma       = M_.params(3);
% delta       = M_.params(4);
% upsilon     = M_.params(5);
% varphi      = M_.params(6);
% dis_lab     = M_.params(7);
% kappa_p     = M_.params(8);
% kappa_w     = M_.params(9);
% epsilon_p   = M_.params(10);
% epsilon_w   = M_.params(11);
% psi         = M_.params(12);
% psi_w       = M_.params(13);
% gamma_p     = M_.params(14);
% gamma_w     = M_.params(15);
% theta       = M_.params(16);
% chi         = M_.params(17);
% lambda_b_k  = M_.params(18);
% rho         = M_.params(19);
% r_c         = M_.params(20);
check       = 0;

load parametervalues;
%set_param_value('g_y_ss'            ,par.g_y);
%set_param_value('qb_y_ss'           ,par.qb_y);
%set_param_value('qb_max_y_ss'       ,par.qb_max_y);
%set_param_value('Gamma'             ,par.Gamma);
%set_param_value('h'                 ,par.h_ss);
%set_param_value('pi'                ,par.pi_ss);
%set_param_value('q_k'               ,par.q_k_ss);
%set_param_value('z'                 ,par.z_ss);
%set_param_value('ksi'               ,par.ksi_ss);
%set_param_value('c_shock'           ,par.c_shock_ss);
%set_param_value('x'                 ,par.x_ss);
%set_param_value('phi'               ,par.phi_ss);
%set_param_value('r_c'               ,par.r_c);
%set_param_value('quarters'          ,par.quarters);


%g_y_ss              = 0.178;            % steady state ratio of government spending over output
%qb_y_ss             = 3.2;              % steady state ratio of government liabilities (q_t^b*b_t) over quarterly output
%qb_max_y_ss         = 2.4;              % steady state level of maximum government liabilities (q_t^b*b_t^max) over quarterly output
%Gamma               = 0.0047;           % steady state spread between loans/bonds and deposits
%h                   = 1/3;              % steady state value of labor
%pi                  = 1.005;            % steady state value for the inflation rate (2 percent annual inflation)
%q_k                 = 1;                % steady state value of capital price
%z                   = 1;                % steady state value of productivity
%ksi                 = 1;                % steady state value of capital quality variable
%c_shock             = 1;                % steady state value of investment adjustment costs shock
%x                   = 1;                % steady state growth of assets
%phi                 = 5.1;              % steady state leverage ratio
%r_c                 = 0.041;            % coupon payment in real terms on government consols
%quarters            = 25;               % effective maturity of long-term government bonds
g_y_ss              = par.g_y;          % steady state ratio of government spending over output
qb_y_ss             = par.qb_y;         % steady state ratio of government liabilities (q_t^b*b_t) over quarterly output
qb_max_y_ss         = par.qb_max_y;     % steady state level of maximum government liabilities (q_t^b*b_t^max) over quarterly output
Gamma               = par.Gamma;        % steady state spread between loans/bonds and deposits
h                   = par.h_ss;         % steady state value of labor
pi                  = par.pi_ss;        % steady state value for the inflation rate (2 percent annual inflation)
q_k                 = par.q_k_ss;       % steady state value of capital price
z                   = par.z_ss;         % steady state value of productivity
ksi                 = par.ksi_ss;       % steady state value of capital quality variable
c_shock             = par.c_shock_ss;   % steady state value of consumption preference shock
h_shock             = par.h_shock_ss;   % steady state value of labor preference shock
i_shock             = par.i_shock_ss;   % steady state value of investment adjustment costs shock
x                   = par.x_ss;         % steady state growth of assets
phi                 = par.phi_ss;       % steady state leverage ratio
% r_c                 = par.r_c;          % coupon payment in real terms on government consols
quarters            = par.quarters;     % effective maturity of long-term government bonds
p_def               = 0;                % steady state default probability
n_g                 = 0;                % steady state value of government assistance to financial sector
n_g_til             = 0;                % steady state value of payback of financial assistance from financial sector to government
aa                  = 0;                % steady state value of coefficient relating government support and previous period net worth of individual intermediaries
bb                  = 0;                % steady state value of tax rate on previous period net worth


% Financial steady state values and parameters

r_d                         = 1/beta-1;                         % steady state value for the net return on the deposits
R_d                         = 1+r_d;                            % steady state value for the gross return on the deposits
pi_adj                      = pi^(gamma_p);                     % steady state value inflation indexation
pi_star                     = 1;                                % steady state value for the inflation rate
r_n                         = (1+r_d)*pi-1;                     % steady state value for the net nominal interest rate
% r_n                         = (1+r_d)*pi;                       % steady state value for the nominal interest rate (redefining r_n as the gross interest rate)
R_n                         = 1+r_n;                            % steady state value for the gross nominal interest rate
Delta                       = 1;                                % steady state value of Delta
r_k                         = r_d+Gamma;                        % steady state value of net return on loans
R_k                         = 1+r_k;                            % steady state value of gross return on loans
Erk                         = r_k;                              % steady state value of expected interest rate on loans
Ecs                         = Gamma;                            % steady state value of expected credit rate spread
x_k                         = x;                                % steady state growth of private loans
x_b                         = x;                                % steady state growth of government bonds

omega                       = pi;                               % steady state value for the wage-inflation rate (2 percent annual wage-inflation)
omega_adj                   = omega^(gamma_w);                  % steady state wage-indexation
omega_new                   = 1;                                % steady state value for the wage-inflation rate
Delta_w                     = 1;                                % steady state wage-dispersion


% Production steady state values and parameters
m                           = (epsilon_p-1)/epsilon_p;                          % steady state value of relative price of intermediate goods with respect to general price level
w                           = (alpha^(alpha)*(1-alpha)^(1-alpha)*m/(r_k+delta)^(alpha))^(1/(1-alpha));              % steady state value of wage rate
kh_ss                       = (alpha/(1-alpha))*w/(r_k+delta);                                                      % steady state value of capital-labor ratio

k                           = kh_ss*h;                                          % steady state value of capital
y                           = z*(ksi*k)^(alpha)*h^(1-alpha);                    % steady state value of output
i                           = delta*k;                                          % steady state value of investment
g                           = g_y_ss*y;                                         % steady state value of government spending
g_til                       = g;                                                % steady state value of regular government spending
c                           = y-i-g;                                            % steady state value of consumption
lambda                      = (1-beta*upsilon)/((1-upsilon)*c);                 % steady state value of marginal utility of consumption
Ksi_1                       = 1;                                                % steady state value of Ksi_1
Ksi_2                       = 1;                                                % steady state value of Ksi_2
Ksi_1_w                     = 1;                                                % steady state value of Ksi_1_w
Ksi_2_w                     = 1;                                                % steady state value of Ksi_2_w
dis_lab                     = ((epsilon_w-1)/epsilon_w)*lambda*w/(h_shock*h^varphi);     % disutility of labor constant

% sovereign debt variables
qb                          = qb_y_ss*y;                                        % steady state level of government liabilities (q_t^b*b_t)
qb_max                      = qb_max_y_ss*y;                                    % steady state level of maximum government liabilities (q_t^b*b_t^max)


% rho                         = 1/quarters;                                       % maturity structure parameter. Expected life of debt is equal to 1/par.rho
q_b                         = (1-p_def*vartheta_cf)*r_c/((1+r_d+lambda_b_k*(r_k-r_d))*pi-(1-p_def*vartheta_p)*(1-rho));      % steady state bond price
% q_b                         = r_c/((1+r_d+lambda_b_k*(r_k-r_d))*pi-(1-rho));    % steady state bond price
r_b                         = (r_c+(1-rho)*q_b)/(pi*q_b)-1;                     % steady state net return on government consols before default
R_b                         = 1+r_b;                                            % steady state gross return on government consols before default
Erb                         = r_b;                                              % steady state expected return on government consols before default
tau                         = g+r_b*qb+n_g-n_g_til;                             % steady state level of lump sum taxes
b                           = qb/q_b;                                           % steady state number of government bonds
b_max                       = qb_max/q_b;                                       % steady state maximum number of government bonds


% Financial variables continued
s_k                         = k;                                                % steady state value of loans to production sector
s_b                         = b;                                                % steady state value of loans to government
p                           = q_k*s_k+q_b*s_b;                                  % steady state value of the assets of the financial intermediaries                                     
weight                      = (q_k*s_k)/p;                                      % steady state value of share of assets invested in loans to production sector
r_p                         = (1+r_k)*weight+(1+r_b)*(1-weight)-1;              % steady state value of interest rate on portfolio
Erp                         = r_p;                                              % steady state value of expected portfolio return
n                           = (q_k*s_k+lambda_b_k*q_b*s_b)/phi;                 % steady state value of net worth banks
d                           = p-n;                                % steady state value of deposits of banks

% theta                       = (1-chi)*n/((r_k-r_d)*q_k*s_k+(r_b-r_d)*q_b*s_b+(1+r_d)*n);                    % calculate theta in case we are estimating chi
eta                         = beta*(1-theta)*(1+r_d)/(1-beta*theta*((1+r_d)+Gamma*phi));  % steady state values eta
nu_k                        = (Gamma/(1+r_d))*eta;                              % steady state values nu_k
% sdf                         = beta*(1-theta+theta*(eta+nu_k*phi));              % steady state value of stochastic discount factor
nu_b                        = lambda_b_k*nu_k;                                  % steady state values nu_b
% nu_b                        = sdf*(r_b-r_d-p_def*((vartheta_cf*r_c+vartheta_p*(1-rho)*q_b)/(pi*q_b)));

lambda_k                    = nu_k+eta/phi;                                     % calibrated parameter value for fraction of private loans banker can divert
lambda_b                    = lambda_b_k*lambda_k;                              % calibrated parameter value for fraction of government bonds banker can divert
mu                          = nu_k/(lambda_k-nu_k);                             % steady state value shadow value of bank balance sheet constraint
welf                        = (log(c-upsilon*c)-dis_lab*h^(1+varphi)/(1+varphi))/(1-beta);    % steady state value of welfare

y_obs                       = 0;
c_obs                       = 0;
i_obs                       = 0;
Ecs_obs                     = 0;
s_k_obs                     = 0;
pi_obs                      = 0;
w_obs                       = 0;
h_obs                       = 0;
n_obs                       = 0;
d_obs                       = 0;


loglin = 2;

if (loglin == 1)
ys      = [c; lambda; h; welf;...
            nu_k; nu_b; eta; phi; mu; n; s_k; s_b; p; d; weight; x; x_k; x_b;... 
            q_k; q_b; r_k; r_b; r_d; r_p; Erk; Erb; Ecs; Erp;...
            w; m; pi; pi_star; pi_adj; Ksi_1; Ksi_2; Delta;...
            omega; omega_new; omega_adj; Ksi_1_w; Ksi_2_w; Delta_w;...
            i; k; y;...
            b; g; g_til; n_g; n_g_til; tau; aa; bb;...
            r_n;...
            p_def; b_max;...  
            z; ksi; lambda_k; lambda_b;...
            c_shock; h_shock; i_shock; epsilon_p; epsilon_w;...
            R_k; R_b; R_d; R_n;...
            y_obs; c_obs; i_obs; Ecs_obs; s_k_obs; pi_obs; w_obs; h_obs; n_obs; d_obs];  
else
ys      = [log(c); log(lambda); log(h); welf;...
            log(nu_k); log(nu_b); log(eta); log(phi); log(mu); log(n); log(s_k); log(s_b); log(p); log(d); log(weight); x; x_k; x_b;... 
            log(q_k); log(q_b); r_k; r_b; r_d; r_p; Erk; Erb; Ecs; Erp;...
            log(w); log(m); log(pi); log(pi_star); log(pi_adj); log(Ksi_1); log(Ksi_2); log(Delta);...
            log(omega); log(omega_new); log(omega_adj); log(Ksi_1_w); log(Ksi_2_w); log(Delta_w);...
            log(i); log(k); log(y);...
            log(b); log(g); log(g_til); n_g; n_g_til; log(tau); aa; bb;...
            r_n;...
%             log(r_n);...
            p_def; log(b_max);...  
            z; ksi; log(lambda_k); log(lambda_b);...
            c_shock; h_shock; i_shock; epsilon_p; epsilon_w;...
            log(R_k); log(R_b); log(R_d); log(R_n);...
            y_obs; c_obs; i_obs; Ecs_obs; s_k_obs; pi_obs; w_obs; h_obs; n_obs; d_obs];
end

end